#include "DHT11.h"

void  DHT11_Start(){
   output_drive(Data_DHT11);
   output_low(Data_DHT11);
   delay_ms(20);
   output_high(Data_DHT11);
   output_float(Data_DHT11);
}

void  DHT11_Response(){
   while(input_state(Data_DHT11)){};
   while(!input_state(Data_DHT11)){};
   while(input_state(Data_DHT11)){};  
}

int DHT11_ReadByte(){
   int i,data = 0;  
   for(i=0;i<8;i++){        
      while(!input_state(Data_DHT11)){
      }
      delay_us(30);         
      if(input_state(Data_DHT11)){  
         data = ((data<<1) | 1); 
      }
      else{
         data = (data<<1);  
      }
      while(input_state(Data_DHT11)){
      }
   }
   return data;
}

int DHT11_ReadData(int *info){
   int temp = 0;
   DHT11_Start();
   DHT11_Response();
   info[0] = DHT11_ReadByte();   //Humedad entero
   info[1] = DHT11_ReadByte();   //Humedad decimal
   info[2] = DHT11_ReadByte();   //Temp entero
   info[3] = DHT11_ReadByte();   //Temp decimal
   info[4] = DHT11_ReadByte();   //Paridad
   temp = info[0] + info[1] + info[2] + info[3];
   if (temp == info[4]){
      return 1;
   }
   else{
      return 0;
   }
}
