#include    <18f4550.h>
#Fuses      HSPLL, NOWDT, NOPROTECT, NOLVP, NODEBUG, USBDIV, PLL2, CPUDIV1, VREGEN
#use        delay (clock=48M)         //Seleccionamos la frecuencia de reloj de 48MHz
#include    <MLCD.c> 
#use        standard_io(c)
#include    "DHT11.c"

int   valores[5]={0,0,0,0,0}; // Almacena los 40 bits recibidos
int   dataOK = 0;

void  main(void){
      lcd_init();

      while(true){
         dataOK = DHT11_ReadData(valores);
         if (dataOK){
            printf(lcd_putc, "\fSens");
            lcd_gotoxy(1,2);
            printf(lcd_putc, "DHT11");
            lcd_gotoxy(7,1);
            printf(lcd_putc, "Hum=%2d.%1d%%", valores[0],valores[1]);
            lcd_gotoxy(7,2);
            printf(lcd_putc, "Tem=%2d.%1dC", valores[2],valores[3]);
         }
         else{
            printf(lcd_putc, "\f NO CONNECTED");
         }
         delay_ms(1500);
      }  
}   
