///////////////////////////////////////////////////////////////////////////////
//                   Configura la ubicacin de los pines                     //
///////////////////////////////////////////////////////////////////////////////
#define     Data_DHT11  PIN_B0

///////////////////////////////////////////////////////////////////////////////
//  Esta biblioteca permite al usuario obtener la informacin de la humedad  //
//  y la temperatura del sensor DHT11.                                       //
//                                                                           //
//  Es importante configurar los pines en la biblioteca para que se adecuen  //
//  a las conexiones de tu tarjeta                                           //
//                                                                           //
/////////////////////////////  OBTENER LA INFORMACIN /////////////////////////
//                                                                           //
//  Para leer la informacin del sensor el usuario tiene que utilizar la     //
//  siguiente funcin:                                                       //
//                                                                           //
//       int DHT11_ReadByte(int *info) :                                     //
//                      Guarda los valores recibidos:                        //
//                         info[0] : Humedad entero                          //
//                         info[1] : Humedad decimal                         //
//                         info[2] : Temperatura entero                      //
//                         info[3] : Temperatura decimal                     //
//                         info[4] : Paridad                                 //
//                  Regresa 1 : Si la informacin se recibi correctamente   //
//                  Regresa 0 : Si la informacin no se recibi correctamente//
///////////////////////////////////////////////////////////////////////////////


//Prototipos de funciones
void        DHT11_Start();
void        DHT11_Response();
int         DHT11_ReadByte();
int         DHT11_ReadData(int *info);
